SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-Morphs'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-AdminTool'!
SystemOrganization addCategory: #'Xpf-Client-Models'!

PasteUpMorph subclass: #XpfProjectMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfProjectMorph class methodsFor: 'initialize-release' stamp: 'topa 3/4/2009 00:08'!
forProject: anXpfProject

	^ self new model: anXpfProject! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'cs 2/26/2009 18:57'!
addUserStoryMorph: anXpfUserStoryMorph

	^ self addMorph:
		"Places new UserStories in the top left corner with 5 indent"
		(anXpfUserStoryMorph topLeft: (self submorphCount * 5 asPoint))! !

!XpfProjectMorph methodsFor: 'initialization' stamp: 'topa 3/3/2009 20:18'!
buildUserStorySubmorphs

	self model userStories do: [ :userStory| 
		self addUserStoryMorph: (XpfUserStoryMorph forUserStory: userStory)]! !

!XpfProjectMorph methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:03'!
initialize

	super initialize.
	self acquireBorderWidth: 5.! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 12:14'!
model: anObject

	self removeAllMorphsIn: self userStorySubmorphs. 
	model := anObject.
	self buildUserStorySubmorphs.
! !

!XpfProjectMorph methodsFor: 'accessing' stamp: 'SR 2/23/2009 10:51'!
userStorySubmorphs

	^ self allMorphs select: [:aMorph| aMorph isUserStoryMorph]! !

XpfTestCase subclass: #XpfAdminToolTest
	instanceVariableNames: 'sut factoryMock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfAdminToolTest methodsFor: 'setup' stamp: 'mt 3/6/2009 16:29'!
setUp

	super setUp.
	sut := XpfAdminTool new.
	factoryMock := XpfProxyObjectFactoryMock new.
	sut initializeWith: factoryMock.
	
	sut projectList selectionIndex: 1.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	
	sut userList selectionIndex: 1.
	sut userList changeModelSelection: sut userList selectionIndex.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 16:07'!
testAddDeveloperToProject
	
	sut projectList selectionIndex: 1.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	
	self
		should: factoryMock getAllProjects first developers size = 0;
		should: sut projectDeveloperList getList size = 0;
		should: sut projectUserDropList listMorph getList size = 2.
	
	sut projectUserDropList listSelectionIndex: 2.
	sut projectAddDeveloperButton performAction.
	
	self
		should: factoryMock getAllProjects first developers size = 1;
		should: factoryMock getAllProjects first developers first = factoryMock getAllUsers second;
		should: sut projectDeveloperList getList size = 1;
		should: sut projectUserDropList listMorph getList size = 1.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 10:14'!
testAddProject
	
	| projectCount |
	projectCount := sut model projects size.
	sut projectAddButton performAction.
	
	self
		should: sut model projects size = (projectCount + 1);
		should: sut projectList selectionIndex = (projectCount + 1).! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 10:59'!
testAddUser
	
	| userCount |
	userCount := sut model users size.
	sut userAddButton performAction.
	
	self
		should: sut model users size = (userCount + 1);
		should: sut userList selectionIndex = (userCount + 1).! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 13:43'!
testDeleteProject
	
	| projectCount projectTitle |
	projectCount := sut model projects size.
	sut projectList changeModelSelection: 1.
	projectTitle := sut projectList selection.
	sut projectDeleteButton performAction.
	
	self
		should: sut model projects size = (projectCount - 1);
		should: sut projectList selectionIndex = 1;
		shouldnt: sut projectList selection = projectTitle.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 13:44'!
testDeleteUser
	
	| userCount userName |
	userCount := sut model users size.
	sut userList changeModelSelection: 1.
	userName := sut userList selection.
	sut userDeleteButton performAction.
	
	self
		should: sut model users size = (userCount - 1);
		should: sut userList selectionIndex = 1;
		shouldnt: sut userList selection = userName.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 13:40'!
testEditProjectTitle
	
	sut projectTitleEntry setText: 'testEditProjectTitle'.
	sut saveProjectButton performAction.
	
	self
		should: sut projectList selection = 'testEditProjectTitle';
		should: sut model projects first title = 'testEditProjectTitle'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 14:53'!
testEditUserLogin
	
	sut userLoginEntry setText: 'testEditUserLogin'.
	sut saveUserButton performAction.
	
	self
		should: sut userList selection = sut model users first userName;
		should: sut model users first login = 'testEditUserLogin'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/4/2009 14:52'!
testEditUserName
	
	sut userNameEntry setText: 'testEditUserName'.
	sut saveUserButton performAction.
	
	self
		should: sut userList selection = 'testEditUserName';
		should: sut model users first userName = 'testEditUserName'.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 14:36'!
testGetAllProjects
	
	self
		should: sut projectList getList size = 2;
		should: sut projectList getList first = factoryMock getAllProjects first title;
		should: sut projectList getList second = factoryMock getAllProjects second title.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/5/2009 13:44'!
testGetAllUsers
	
	self
		should: sut userList getList size = 2;
		should: sut userList getList first = factoryMock getAllUsers first userName.! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 14:38'!
testSelectProject
	
	sut projectList selection: factoryMock projectTitle.
	sut projectList changeModelSelection: sut projectList selectionIndex.
	
	self
		should: sut projectList selectionIndex = 2;
		should: sut projectTitleEntry text = factoryMock projectTitle;
		should: sut projectDeveloperList getList size = 2;
		should: sut projectDeveloperList getList first = factoryMock getAllUsers first userName;
		should: sut projectDeveloperList getList second = factoryMock getAllUsers second userName.
		! !

!XpfAdminToolTest methodsFor: 'tests' stamp: 'mt 3/6/2009 13:30'!
testSelectUser
	
	sut userList selection: factoryMock userName.
	sut userList changeModelSelection: sut userList selectionIndex.
	
	self
		should: sut userList selectionIndex = 2;
		should: sut userNameEntry text = factoryMock userName;
		should: sut userLoginEntry text = factoryMock userLogin.! !

XpfTestCase subclass: #XpfClientTest
	instanceVariableNames: 'project userstory1 userstory2 sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfClientTest methodsFor: 'running' stamp: 'topa 3/4/2009 00:32'!
setUp

	super setUp.
	self setupFixtures.
	sut := XpfClient forProject: project.
! !

!XpfClientTest methodsFor: 'running' stamp: 'topa 3/4/2009 00:30'!
setupFixtures

	project := XpfProject new title: 'Test Project'.
	userstory1 := XpfUserStory new
				title: 'Test User Story with long title.';
				explanation: 'This is the explanantion of a user story.'.
	userstory2 := XpfUserStory new title: 'Test User Story'.
	project
		addUserStory: userstory1;
		addUserStory: userstory2! !

!XpfClientTest methodsFor: 'running' stamp: 'topa 3/4/2009 00:27'!
tearDown

	project
		removeUserStory: userstory1;
		removeUserStory: userstory2.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:35'!
testAddUSMorphsToProjectMorph

	| usMorphCount projectMorph |
	projectMorph := XpfProjectMorph new.
	usMorphCount := projectMorph userStorySubmorphs size.
	
	projectMorph addUserStoryMorph: (XpfUserStoryMorph forUserStory: userstory1).
	self should: projectMorph userStorySubmorphs size = (usMorphCount + 1).! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testProjectTitleDisplay

 	self should: sut label = project printString.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testUserStoryDetailWindow

	| sut2 |
	sut2 := XpfUserStoryDetailWindow forUserStory: userstory1.

	self
		should: sut2 titleText getText = userstory1 title
		description: 'The text entry should contain the title of the user story.'.
		
	self
		should: sut2 explanationText getText = userstory1 explanation
		description: 'The explanation is not correct'.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:33'!
testUserStoryDetailWindowOk

	| sut2 newTitle newExp |
	sut2 := XpfUserStoryDetailWindow forUserStory: userstory1.
	
	newTitle := 'Changed Text.'.
	newExp := 'Changed Explanation.'.

	sut2 titleText textMorph contents: newTitle.
	sut2 explanationText textMorph contents: newExp.
	
	self
		shouldnt: userstory1 title = newTitle;
		shouldnt: userstory1 explanation = newExp.
	sut2 ok.
	
	self
		should: userstory1 title = newTitle;
		should: userstory1 explanation = newExp.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:33'!
testUserStorySubmorphs

	| sut2 |
	sut2 := XpfProjectMorph forProject: project.

	self should: sut2 userStorySubmorphs size = project userStories size.

	sut2 userStorySubmorphs do: [ :usMorph| 
		self should: (project userStories includes: usMorph model)].! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:33'!
testUserStoryTextContent

	| sut2 titleMorph |
	sut2 := XpfUserStoryMorph forUserStory: userstory2.
	self should: sut2 submorphCount > 0.
	
	titleMorph := sut2 submorphs detect: [:submorph |
			submorph isTextMorph and: [submorph text asString = userstory2 printString]].
	self
		shouldnt: titleMorph isNil;
		should: (titleMorph wrapString startsWith: '<yes>');
	 	should: titleMorph width <= 100.! !

XpfTestCase subclass: #XpfLoginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfLoginTest methodsFor: 'tests' stamp: 'topa 3/6/2009 14:47'!
testLoginDialog

	| dlg |
	dlg := XpfLogin new.
	
	dlg hostEntry setText: 'example.com'.
	dlg portEntry setText: '8080'.
	dlg loginEntry setText: 'random.guy@web.de'.
	dlg passwordEntry setText: 'secret'.
	
	dlg connectButton performAction.
	
	self
		should: dlg result = 'http://random.guy%40web.de:secret@example.com:8080/'! !

PluggableDialogWindow subclass: #XpfDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

XpfDialog subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry userLoginEntry saveProjectButton saveUserButton projectAddButton userAddButton projectDeleteButton userDeleteButton userPasswordButton projectDeveloperList projectUserDropList projectAddDeveloperButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminTool class methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:44'!
open

	| instance connectionString factory response|
	instance := self new.
	connectionString := (instance openModal: XpfLogin new) result.
	
	connectionString ifNil: [^ self].

	[response := RestSocket get: connectionString]
		on: ConnectionTimedOut
		do: [:e | UITheme current
			alertIn: instance 
			text: e messageText 
			title: 'Connection timed out'. ^ self].
	
	response responseCode = 401 ifTrue: [UITheme current
		alertIn: instance 
		text: 'You are not authorized to access any resource on the server.' 
		title: 'Connection failed'. ^ self].
	
	factory := XpfProxyObjectFactory fromString: connectionString.
	^ (instance initializeWith: factory) openInWorld! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 10:21'!
createProjectAddButtonFor: myModel 

	self projectAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addProject
		arguments: nil
		getEnabled: nil
		label: 'Add Project'
		help: 'Add new project').
	^ self projectAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 16:37'!
createProjectAddDeveloperButtonFor: myModel 

	self projectAddDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addDeveloperToProject
		arguments: nil
		getEnabled: #hasCurrentProjectCandidateIndex
		label: 'Add'
		help: 'Add the candidate as developer to this project.').
	^ self projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:15'!
createProjectDeleteButtonFor: myModel 

	self projectDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteProject
		arguments: nil
		getEnabled: #hasProjects
		label: 'Delete Project'
		help: 'Delete project').
	^ self projectDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:48'!
createProjectDeveloperListFor: aModel

	self projectDeveloperList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectDeveloperNames
		selected: #currentProjectDeveloperIndex
		changeSelected: #currentProjectDeveloperIndex:
		getEnabled: nil
		help: 'Shows all developers of this project.').
	^ self projectDeveloperList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:21'!
createProjectListFor: aModel

	self projectList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		getEnabled: nil
		help: 'Shows all projects.').
	^ self projectList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:20'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
		class: String
		getEnabled: #hasCurrentProject
		help: 'Enter a short descriptive title for this project.') maxLength: 100).
	^ self projectTitleEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:49'!
createProjectUserDropListFor: aModel

	self projectUserDropList: (UITheme current
		newDropListIn: self
		for: aModel
		list: #allProjectCandidateNames
		getSelected: #currentProjectCandidateIndex
		setSelected: #currentProjectCandidateIndex:
		getEnabled: #hasCurrentProjectCandidates
		useIndex: true
		help: 'All available users for this project').
	^ self projectUserDropList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:37'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButton}.
		self createHSeparator.
		self createRow: {self createLabel: 'Developers:'. self createHFiller}.
		self createProjectDeveloperListFor: myModel.
		self createRow: {
			self createLabel: 'Candidate:'. 
			self createProjectUserDropListFor: myModel. 
			self createProjectAddDeveloperButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createProjectListFor: myModel. 
			self createRow: {
				self createProjectAddButtonFor: myModel. 
				self createProjectDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/4/2009 11:07'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #ok
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:30'!
createSaveProjectButton

	self saveProjectButton: (UITheme current 
		newButtonIn: self
		for: self projectTitleEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: #enabled
		label: 'Save'
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:35'!
createSaveUserButtonFor: myModel

	self saveUserButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #updateUser:
		arguments: {{self userNameEntry. self userLoginEntry}}
		getEnabled: #hasCurrentUser
		label: 'Save'
		help: 'Save changed user data').
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 11:00'!
createUserAddButtonFor: myModel 

	self userAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addUser
		arguments: nil
		getEnabled: nil
		label: 'Add User'
		help: 'Add new user').
	^ self userAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:05'!
createUserDeleteButtonFor: myModel 

	self userDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteUser
		arguments: nil
		getEnabled: #hasUsers
		label: 'Delete User'
		help: 'Delete User').
	^ self userDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserListFor: aModel

	self userList: (UITheme current
		newListIn: self
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		getEnabled: nil
		help: 'Shows all users.').
	^ self userList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:03'!
createUserLoginEntryFor: myModel

	self userLoginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserLogin
		set: #currentUserLogin:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter a valid email address') maxLength: 100).
	^ self userLoginEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserNameEntryFor: myModel

	self userNameEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserName
		set: #currentUserName:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter the name of the user.') maxLength: 100).
	^ self userNameEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:35'!
createUserPasswordButtonFor: myModel 

	self userPasswordButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #changePassword:
		arguments: {self}
		getEnabled: #hasCurrentUser
		label: 'Change Password...'
		help: 'Change the current password').
	^ self userPasswordButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:36'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {
			self createLabel: 'Name:'. 
			self createUserNameEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Login/E-Mail:'. 
			self createUserLoginEntryFor: myModel}.
		self createRow: {
			self createUserPasswordButtonFor: myModel.
			self createHFiller. 
			self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createUserListFor: myModel. 
			self createRow: {
				self createUserAddButtonFor: myModel. 
				self createUserDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:26'!
initializeUserInterface: myModel

	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/5/2009 14:14'!
initializeWith: aFactory

	| myModel |
	myModel := XpfAdminToolModel newWithFactory: aFactory.
	self
		buttons: {self createQuitButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton
	^ projectAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton: anObject
	projectAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton
	^ projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton: anObject
	projectAddDeveloperButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton
	^ projectDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton: anObject
	projectDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList
	^ projectDeveloperList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList: anObject
	projectDeveloperList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList
	^ projectUserDropList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList: anObject
	projectUserDropList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'updating' stamp: 'mt 3/4/2009 14:45'!
updateUser
	"Accepts all user-data-specific controls to force update of model."
	
	self userNameEntry accept.
	self userLoginEntry accept.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton
	^ userAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton: anObject
	userAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton
	^ userDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton: anObject
	userDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry
	^ userLoginEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry: anObject
	userLoginEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton
	^ userPasswordButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton: anObject
	userPasswordButton := anObject! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createCol: someElements

	^ UITheme current newColumnIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createHFiller

	^ (UITheme current newToolSpacerIn: self) hResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createHSeparator

	^ UITheme current newSeparatorIn: self! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createLabel: aString

	^ UITheme current
		newLabelIn: self
		label: aString! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createRow: someElements

	^ UITheme current newRowIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVFiller

	^ (UITheme current newToolSpacerIn: self) vResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVSeparator

	^ (UITheme current newSeparatorIn: self) hResizing: #rigid; vResizing: #spaceFill! !

!XpfDialog methodsFor: 'initialization' stamp: 'topa 3/6/2009 14:53'!
initializeUserInterface: aModel

	self subclassResponsibility.! !

XpfDialog subclass: #XpfLogin
	instanceVariableNames: 'hostEntry portEntry loginEntry passwordEntry connectButton cancelButton result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
cancelButton

	^ cancelButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
connectButton

	^ connectButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
connectButton: anObject

	connectButton := anObject.! !

!XpfLogin methodsFor: 'user interface' stamp: 'mt 3/6/2009 10:47'!
createCancelButton 

	self cancelButton: (UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close login window').
	^ self cancelButton! !

!XpfLogin methodsFor: 'user interface' stamp: 'mt 3/6/2009 10:46'!
createConnectButton 

	self connectButton: (UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #ok
		arguments: nil
		getEnabled: nil
		label: 'Connect'
		help: 'Try to connect to server').
	^ self connectButton! !

!XpfLogin methodsFor: 'user interface' stamp: 'mt 3/6/2009 10:43'!
createHostEntryFor: myModel

	self hostEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #host
		set: #host:
		class: String
		getEnabled: nil
		help: 'Enter the host data of the server.') maxLength: 100).
	^ self hostEntry minWidth: 200! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createLoginEntryFor: myModel

	self loginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #login
		set: #login:
		class: String
		getEnabled: nil
		help: 'Enter login') maxLength: 100).
	^ self loginEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createPasswordEntryFor: myModel

	self passwordEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #password
		set: #password:
		class: String
		getEnabled: nil
		help: 'Enter password') maxLength: 100).
	self passwordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self passwordEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'mt 3/6/2009 11:01'!
createPortEntryFor: myModel

	self portEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #port
		set: #port:
		class: String
		getEnabled: nil
		help: 'Enter the port') maxLength: 5).
	^ self portEntry minWidth: 70! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
hostEntry

	^ hostEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
hostEntry: anObject

	hostEntry := anObject.! !

!XpfLogin methodsFor: 'initialization' stamp: 'mt 3/6/2009 11:01'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfLoginModel new.
	self
		buttons: {self createConnectButton. self createCancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'AdminTool - Login'.! !

!XpfLogin methodsFor: 'initialization' stamp: 'mt 3/6/2009 10:50'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Host:'.
			self createHostEntryFor: myModel.
			self createLabel: 'Port:'.
			self createPortEntryFor: myModel}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Login:'.
			self createLoginEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Password:'.
			self createPasswordEntryFor: myModel}}! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry

	^ loginEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry: anObject

	loginEntry := anObject! !

!XpfLogin methodsFor: 'initialization' stamp: 'mt 3/6/2009 12:00'!
ok

	self hostEntry accept.
	self portEntry accept.
	self loginEntry accept.
	self passwordEntry accept.
			
	self result: self model connectString.
	
	^ super ok! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry

	^ passwordEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry: anObject

	passwordEntry := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
portEntry

	^ portEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
portEntry: anObject

	portEntry := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result

	^ result! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result: anObject

	result := anObject.! !

PluggableDialogWindow subclass: #XpfUserStoryDetailWindow
	instanceVariableNames: 'explanationText titleText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfUserStoryDetailWindow class methodsFor: 'instance creation' stamp: 'topa 3/3/2009 20:51'!
forUserStory: aUserStory

	^ self new initializeWith: aUserStory! !

!XpfUserStoryDetailWindow methodsFor: 'actions' stamp: 'cs 2/26/2009 19:09'!
close
	
	super close.
	self changed: #detailsClosed.! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:05'!
createExplanationTextFor: aUserStory

	self explanationText: (UITheme current
		newTextEditorIn: self
		for: aUserStory
		getText: #explanation
		setText: #explanation:
		getEnabled: nil).
	^ self explanationText alwaysAccept: true
! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:05'!
createLabel

	^ UITheme current
		newLabelIn: self
		label: 'Title:'! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'topa 3/4/2009 00:06'!
createTitleTextFor: aUserStory

	self titleText: ((UITheme current
		newTextEntryIn: self
		for: aUserStory
		get: #title
		set: #title:
		class: String
		getEnabled: nil
		help: 'Enter a short descriptive title for this user story.') 
	maxLength: 100).
	^ self titleText! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:06'!
explanationText

	^ explanationText! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:06'!
explanationText: anObject

	explanationText := anObject.! !

!XpfUserStoryDetailWindow methodsFor: 'initialization' stamp: 'mt 2/26/2009 17:39'!
initializeWith: aUserStory

	| col row |	
	row := UITheme current newRowIn: self for: {
		self createLabel.
		self createTitleTextFor: aUserStory}.
		
	col := UITheme current newColumnIn: self for: {
		row.
		self createExplanationTextFor: aUserStory}.
		
	self
		contentMorph: col;
		model: aUserStory;
		addGrips;
		title: aUserStory title.! !

!XpfUserStoryDetailWindow methodsFor: 'actions' stamp: 'cs 2/26/2009 19:10'!
ok

	self titleText accept.
	self explanationText accept.	
	self changed: #detailsClosed.
	super ok.! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:07'!
titleText

	^ titleText! !

!XpfUserStoryDetailWindow methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:07'!
titleText: anObject

	titleText := anObject.! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'factory projects currentProjectIndex users currentUserIndex currentProjectCandidateIndex currentProjectDeveloperIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'topa 3/3/2009 20:19'!
newWithFactory: aFactory

	^ self new factory: aFactory! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/6/2009 16:40'!
addDeveloperToProject

	(self projects at: self currentProjectIndex) developers add: 
		(self currentProjectCandidates
			at: self currentProjectCandidateIndex).
			
	self currentProjectCandidateIndex: 0.
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:23'!
addProject

	factory addProject: (Dictionary newFrom: {'title' -> 'New Project'}).
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: self projects size;
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:31'!
addUser

	factory addUser: (Dictionary newFrom: {'userName' -> 'New User'. 'login' -> 'new.user@email.de'. 'password' -> nil}).
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: self users size;
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:47'!
allProjectCandidateNames

	^ self currentProjectCandidates collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
allProjectDeveloperNames

	^ self currentProjectDevelopers collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 14:00'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/6/2009 13:40'!
changePassword: aDialog

	| newPassword |
	newPassword := UITheme current 
		textEntryIn: aDialog
		text: ('Enter new password for ''{1}''' format: {self currentUserName})
		title: 'Change Password'
		entryText: ''.
				
	newPassword ifNil: [^ self].
	
	self currentUserPassword: newPassword! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:17'!
currentProjectCandidateIndex
	^ currentProjectCandidateIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:38'!
currentProjectCandidateIndex: anObject

	currentProjectCandidateIndex := anObject.
	self
		changed: #currentProjectCandidateIndex;
		changed: #hasCurrentProjectCandidateIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:47'!
currentProjectCandidates

	self hasCurrentProject ifFalse: [^ #()].

	^ self users reject: [:user | 
		(self projects at: self currentProjectIndex) developers anySatisfy: [:dev | dev id = user id]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:17'!
currentProjectDeveloperIndex
	^ currentProjectDeveloperIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:43'!
currentProjectDeveloperIndex: anObject

	currentProjectDeveloperIndex := anObject.
	self changed: #currentProjectDeveloperIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
currentProjectDevelopers

	self hasCurrentProject ifFalse: [^ #()].

	^ (self projects at: self currentProjectIndex) developers ! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:34'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #hasCurrentProject;
		changed: #currentProjectIndex;
		changed: #currentProjectTitle;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:22'!
currentProjectTitle

	^ self hasCurrentProject
		ifTrue: [self allProjectTitles at: self currentProjectIndex]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
currentProjectTitle: aString

	(self projects at: self currentProjectIndex) title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:34'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #hasCurrentUser;
		changed: #currentUserIndex;
		changed: #currentUserName;
		changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 14:46'!
currentUserLogin

	^ (self users at: self currentUserIndex ifAbsent: [XpfUser new]) login! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 14:46'!
currentUserLogin: aString

	(self users at: self currentUserIndex) login: aString.
	self changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 14:04'!
currentUserName: aString

	(self users at: self currentUserIndex) userName: aString.
	self
		changed: #currentUserName;
		changed: #allUserNames.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 13:32'!
currentUserPassword: aString

	(self users at: self currentUserIndex) password: aString.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:51'!
deleteProject

	(self projects at: self currentProjectIndex) delete.
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self currentProjectIndex > self projects size 
			ifTrue: [self projects size] 
			ifFalse: [self currentProjectIndex]);
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:31'!
deleteUser

	(self users at: self currentUserIndex) delete.
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self currentUserIndex > self users size 
			ifTrue: [self users size] 
			ifFalse: [self currentUserIndex]);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:24'!
factory

	^ factory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:24'!
factory: anObject

	factory := anObject.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:35'!
hasCurrentProject

	^ self currentProjectIndex notNil and: 
		[(self currentProjectIndex > 0) & (self currentProjectIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:37'!
hasCurrentProjectCandidateIndex

	^ self currentProjectCandidateIndex notNil and: 
		[(self currentProjectCandidateIndex > 0) & (self currentProjectCandidateIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectCandidates

	^ self currentProjectCandidates isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectDevelopers

	^ self currentProjectDevelopers isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 13:49'!
hasCurrentUser

	^ self currentUserIndex notNil and: 
		[(self currentUserIndex > 0) & (self currentUserIndex <= self users size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 14:05'!
hasProjects

	^ self projects isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 14:05'!
hasUsers

	^ self users isEmpty not! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 16:20'!
initialize

	super initialize.
	self
		currentProjectIndex: 0;
		currentUserIndex: 0;
		currentProjectCandidateIndex: 0;
		currentProjectDeveloperIndex: 0.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:24'!
projects
	
	^ projects ifNil: [projects := factory getAllProjects]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/5/2009 14:32'!
updateUser: someEntries

	someEntries do: [:entry | entry accept]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:02'!
users

	^  users ifNil: [users := factory getAllUsers]! !

Object subclass: #XpfLoginModel
	instanceVariableNames: 'host port login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:48'!
connectString

	"self password ifEmpty: [^ 'http://{1}@{2}:{3}/' format: {self login encodeForHTTP. self host. self port}]." "not allowed."
	self login ifEmpty: [^ 'http://{3}:{4}/' format: {self host. self port}].
	
	^ 'http://{1}:{2}@{3}:{4}/' format: {self login encodeForHTTP. self password encodeForHTTP. self host. self port}! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:48'!
host

	^ host! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:48'!
host: anObject

	host := anObject.! !

!XpfLoginModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 15:32'!
initialize

	super initialize.
	self
		host: 'localhost';
		port: '8082';
		login: 'admin@example.com';
		password: 'nimda'.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login

	^ login! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login: anObject

	login := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
password

	^ password! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:54'!
password: anObject

	password := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:54'!
port

	^ port! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:54'!
port: anObject

	port := anObject.! !

Object subclass: #XpfProxyObjectFactoryMock
	instanceVariableNames: 'projects users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProxyObjectFactoryMock methodsFor: 'add-remove' stamp: 'mt 3/5/2009 12:14'!
addProject: aDictionary

	^ projects add: (XpfProxyObjectMock new
		entity: (XpfProject newFrom: aDictionary);
		relatives: projects)! !

!XpfProxyObjectFactoryMock methodsFor: 'add-remove' stamp: 'mt 3/5/2009 10:55'!
addUser: aDictionary

	^ users add: (XpfUser newFrom: aDictionary)! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:55'!
getAllProjects

	^ projects! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 10:54'!
getAllUsers

	^ users! !

!XpfProxyObjectFactoryMock methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:32'!
initialize

	super initialize.
	projects := {XpfProxyObjectMock newProjectMock. XpfProxyObjectMock newProjectMock title: self projectTitle} asOrderedCollection.
	users := {XpfProxyObjectMock newUserMock. XpfProxyObjectMock newUserMock login: self userLogin; userName: self userName; password: self userPassword} asOrderedCollection.
	
	projects do: [:project | project relatives: projects].
	users do: [:user | 
		user relatives: users. 
		projects second developers add: user].
! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:39'!
projectTitle

	^ 'test project'! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 11:17'!
userLogin

	^ 'random.guy'! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:17'!
userName

	^ 'Random Guy'! !

!XpfProxyObjectFactoryMock methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:26'!
userPassword

	^ 'topsecret'! !

Object subclass: #XpfProxyObjectMock
	instanceVariableNames: 'entity relatives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

XpfProxyObjectMock class
	instanceVariableNames: 'nextId'!

XpfProxyObjectMock class
	instanceVariableNames: 'nextId'!

!XpfProxyObjectMock class methodsFor: 'instance creation' stamp: 'mt 3/6/2009 16:10'!
newProjectMock

	^ self new entity: (XpfProject new title: 'Born to be deleted'; id: self nextId)! !

!XpfProxyObjectMock class methodsFor: 'instance creation' stamp: 'mt 3/6/2009 16:10'!
newUserMock

	^ self new entity: (XpfUser new userName: 'Mr. Lemming'; id: self nextId)! !

!XpfProxyObjectMock class methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:11'!
nextId

	nextId ifNil: [nextId := 0].
	nextId := nextId + 1.
	^ nextId! !

!XpfProxyObjectMock class methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:10'!
nextId: anObject
	nextId := anObject! !

!XpfProxyObjectMock methodsFor: 'deleting' stamp: 'mt 3/5/2009 12:04'!
delete

	relatives remove: self! !

!XpfProxyObjectMock methodsFor: 'error handling' stamp: 'mt 3/5/2009 12:16'!
doesNotUnderstand: aMessage

	| result |
	result := entity perform: aMessage selector withArguments: aMessage arguments.
	^ result = entity ifTrue: [self] ifFalse: [result]! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
entity
	^ entity! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
entity: anObject
	entity := anObject! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
relatives
	^ relatives! !

!XpfProxyObjectMock methodsFor: 'accessing' stamp: 'mt 3/5/2009 12:05'!
relatives: anObject
	relatives := anObject! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

Morph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'model titleMorph enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultBorderColor

	^ Color darkGray! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultColor

	^ Color paleTan! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultDisabledBorderColor

	^ Color gray! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:07'!
defaultDisabledColor

	^ Color veryVeryLightGray ! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:08'!
defaultDisabledTextColor

	^ Color darkGray! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:08'!
defaultExtent

	^ 100@60 ! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'topa 3/4/2009 00:08'!
defaultTextColor

	^ Color black! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'topa 3/4/2009 00:08'!
forUserStory: anXpfUserStory

	^ self new model: anXpfUserStory! !

!XpfUserStoryMorph methodsFor: 'colorization' stamp: 'topa 3/4/2009 00:16'!
colorizeDisabled

	self 
		color: self class defaultDisabledColor;
		borderColor: self class defaultDisabledTextColor.
	self titleMorph color: self class defaultDisabledBorderColor.! !

!XpfUserStoryMorph methodsFor: 'colorization' stamp: 'topa 3/4/2009 00:15'!
colorizeEnabled

	self 
		color: self class defaultColor;
		borderColor: self class defaultBorderColor.
	self titleMorph color: self class defaultTextColor.! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'topa 3/3/2009 20:18'!
doubleClick: evt

	self enabled: false.
	(XpfUserStoryDetailWindow forUserStory: self model)
		addDependent: self;
		openInHand.! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'cs 2/26/2009 18:24'!
doubleClickTimeout: evt

	evt hand attachMorph: self.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 2/26/2009 18:07'!
enabled

	^ enabled! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:15'!
enabled: aBoolean

	(enabled := aBoolean)
		ifTrue: [self colorizeEnabled]
		ifFalse: [self colorizeDisabled].
! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'cs 2/26/2009 18:24'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryMorph methodsFor: 'initialization' stamp: 'cs 2/26/2009 19:12'!
initialize

	super initialize.
	self
		extent: self class defaultExtent;
		titleMorph: TextMorph new lock;
		borderWidth: 2;
		enabled: true.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:21'!
model

	^ model! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:21'!
model: anObject

	model := anObject.
	self update: #newModel.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:21'!
titleMorph

	^ titleMorph! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:22'!
titleMorph: anObject

	titleMorph ifNotNil: [self removeMorph: titleMorph].
	titleMorph := anObject.
	self addMorph:( titleMorph topLeft: 4@2).! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'topa 3/4/2009 00:23'!
update: aSymbol

	aSymbol = #detailsClosed ifTrue: [self enabled: true].
	self titleMorph
		contents: (self model title truncateWithElipsisTo: 24);
		wrapFlag: true;
		extent: self class defaultExtent.! !

RestProxyObjectFactory subclass: #XpfProxyObjectFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfProxyObjectFactory methodsFor: 'add-remove' stamp: 'cs 2/27/2009 15:21'!
addProject: aProject 

	^ self addObject: 'projects/' with: aProject! !

!XpfProxyObjectFactory methodsFor: 'add-remove' stamp: 'mt 3/5/2009 10:53'!
addUser: aUser 

	^ self addObject: 'users/' with: aUser! !

!XpfProxyObjectFactory methodsFor: 'accessing' stamp: 'topa 3/3/2009 17:46'!
getAllProjects

	^ self getCollection: 'projects/'! !

!XpfProxyObjectFactory methodsFor: 'accessing' stamp: 'mt 3/4/2009 11:16'!
getAllUsers

	^ self getCollection: 'users/'! !

PluggableSystemWindow subclass: #XpfClient
	instanceVariableNames: 'projectMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfClient class methodsFor: 'as yet unclassified' stamp: 'topa 3/6/2009 17:09'!
open

	| instance connectionString factory response|
	instance := self new.
	connectionString := (instance openModal: XpfLogin new) result.
	
	connectionString ifNil: [^ self].

	[response := RestSocket get: connectionString]
		on: ConnectionTimedOut
		do: [:e | UITheme current
			alertIn: instance 
			text: e messageText 
			title: 'Connection timed out'. ^ self].
	
	response responseCode = 401 ifTrue: [UITheme current
		alertIn: instance 
		text: 'You are not authorized to access any resource on the server.' 
		title: 'Connection failed'. ^ self].
	
	factory := XpfProxyObjectFactory fromString: connectionString.
	^ (instance setProject: factory getAllProjects first) openInWorld! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 3/3/2009 20:14'!
initialize

	super initialize.	
	self 
		projectMorph: XpfProjectMorph new;
		addMorph: self projectMorph 
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@0 corner: 0@0)).! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 3/3/2009 20:14'!
model: anXpfProject

	super model: anXpfProject.
	self projectMorph model: anXpfProject.! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 3/3/2009 20:13'!
projectMorph

	^ projectMorph! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:02'!
projectMorph: anObject

	projectMorph := anObject.! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'topa 3/6/2009 17:08'!
setProject: anXpfProject

	self
		model: anXpfProject;
		getLabelSelector: #title.! !

XpfRestTest subclass: #XpfModelToProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'topa 3/4/2009 00:34'!
setUp
	
	| factory |
	super setUp.
	factory := XpfProxyObjectFactory fromString: self class url.
	proxy := factory getAllProjects first.! !

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'topa 3/4/2009 00:34'!
testTitle

	self should: proxy title = testProject title.
	
	proxy userStories with: testProject userStories do: 
		[:proxyUS :realUS |  self should: proxyUS title = realUS title].! !
